/*jslint browser: true, devel: true, for:true, this:true */
/*global jQuery, window, _app_, pagenow, CodeMirror, SignaturePad, wp */
jQuery(document).ready( function ($) {
"use strict";

	function init(){
		/* Set qtip viewport */
		_app_.qtipPos.viewport = $(window);
		_app_.qtipPosLeft.viewport = $(window);
		_app_.qtipPosBottom.viewport = $(window);
		_app_.qtipPosTop.viewport = $(window);
		return;
	}
	init();
	
	if (_app_.is.mobile) {
		$.fn.qtip = function() {
			return $.fn.qtip;
		};
	}
	
	/* Read $_GET url parameter */
	/* https://stackoverflow.com/a/39768285 */
	$.urlParam = function(name){
		return String(location.search.split( name + "=")[1] || "").split("&")[0];
	};

	/* Read hash of the current url */
	$.readHash = function(){
		return String(location.hash);
	};

	/* Catch $_GET vars
	 * http://stackoverflow.com/a/1586333
	 */
	$.readGet = function (name) {
		var part = name;
		var parts = String(window.location.search.substr(1)).split("&");
		var get = {};
		var i;
		var temp;
		for (i = 0; i < parts.length; i = i + 1) {
			temp = parts[i].split("=");
			get[decodeURIComponent(temp[0])] = decodeURIComponent(temp[1]);
		}
		return get[part];
	};

	/* http://phpjs.org/functions/wpb_number_format/ */
	$.numFormat = function(number) {
        var decimals = 2;
		if (parseInt(_app_.curr_decimal) === 0) {decimals=0;}

		number = String(number).replace(/[^0-9+\-Ee.]/g, "");
		var n = !Number.isFinite(Number(number)) ? 0 : Number(number);
		var prec = !Number.isFinite(Number(decimals)) ? 0 : Math.abs(decimals);
		var sep = _app_.thousands_sep;
		var dec = _app_.decimal_sep;
		var s = "";
        var str = "";
		var toFixedFix = function (n, prec) {
			var k = Math.pow(10, prec);
			return Number(Math.round(n * k) / k).toFixed(prec);
		};

        str = prec ? toFixedFix(n, prec) : String(Math.round(n));
		s = str.split(".");
		if (s[0].length > 3) {
			s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
		}
		if (parseInt(s[1] || "").length < prec) {
			s[1] = s[1] || "";
			var arr = [];
			s[1] += arr(prec - s[1].length + 1).join("0");
		}
		return s.join(dec);
	};

	/* Close info panel */
	$.closePanel = function() {
		$(".app-compact-book-wrapper, .app-wrap").css("opacity",1);
		$('div.app-updating-panel').find(".app-updating").text(_app_.done);
		$.unblockUI({ fadeOut: 700 });
	};
	$(document).ajaxStop($.closePanel);

	/* Open info panel */
	$.infoPanel = function(task){
		if (!task || "first_load" === task || "browse" === task) {
			$(".app-compact-book-wrapper, .app-wrap").css("opacity",_app_.opacity);
			if ( "first_load" === task ) {
				return false;
			}
		}

		var msg = ( task && _app_[task] ) ? _app_[task] : _app_.updating_text;
		var is_checkout = task === "booking";
		var panel = $("div#app-updating-panel");
		if (!panel.length) {
			return false;
		}
		
		panel.find(".app-updating").text(msg);

		$.blockUI.defaults.css = {};
		$.blockUI.defaults.themedCSS = {
			width: "auto",
			top: "50%",
			left: "50%",
			right: "initial",
			overflow: "initial",
			"-ms-transform": "translate(-50%, -50%)",
			"-webkit-transform": "translate(-50%, -50%)",
			"transform": "translate(-50%, -50%)"
		};
		if(!$(".blockUI").length) {
			$.blockUI({
				blockMsgClass: "app-blockUI",
				message: panel,
				fadeIn: 200,
				fadeOut: 700,
				theme: is_checkout,
				showOverlay: is_checkout,
				centerY: is_checkout,
				ignoreIfBlocked: true
			});
		}
	};

	/* Add icons to buttons */
	$.styleButtons = function () {
		$(document).on({
			mouseenter: function () {
				$(this).addClass("ui-state-hover");
			},
			mouseleave: function () {
				$(this).removeClass("ui-state-hover");
			}
		}, ".ui-button");

		$(".app-book-now-button").button({
		  icons: { primary: "ui-icon-cart" }
		}).qtip();
		$(".app-conf-cancel-button").button({
		  icons: { primary: "ui-icon-cancel" }
		});
		$(".app-list-cancel").button({
		  icons: { primary: "ui-icon-trash" }
		});
		$(".app-list-confirm").button({
		  icons: { primary: "ui-icon-circle-check" }
		});		
		$(".app-list-pay").button({
		  icons: { primary: "ui-icon-contact" }
		});		
		$(".app-conf-button").button({
		  icons: { primary: "ui-icon-check" }
		});
		$(".app-cont-btn").button({
		  icons: { primary: "ui-icon-arrowreturnthick-1-n" }
		});
		$(".app-list-edit.ui-button").button({
		  icons: { primary: "ui-icon-pencil" }
		});
		$(".app-pdf-button.ui-button").button({
		  icons: { primary: "ui-icon-document" }
		});
		$(".ui-button")
		.addClass("ui-state-default ui-shadow ui-btn-" + _app_.swatch)
		.qtip({style:_app_.qtipDef});
	};

	if (typeof $.fn.datepicker === "function") {
		$.each($(".app-date-field-entry"), function() {
			var $this = $(this);
			$this.datepicker({
				dateFormat: _app_.js_date_format,
				firstDay: _app_.start_of_week,
				maxDate: $this.attr("data-maxdate")
						? $this.data("maxdate")
						: null,
				changeMonth: true,
				changeYear: true,
				monthNamesShort: _app_.monthNamesShort,
				dayNamesMin: _app_.dayNamesMin
			});
		});
	}

	/**
	* Common for Admin and Front
	*/
	var WPB_Common = {
		init: function(){
			this.doBind();
			this.sigPad();
		},
		doBind: function(){
			var me = this;
			$(document).on("click", ".app-disabled-button", function (e) {
				me.disableButton(e);
			});
			$(document).on("click", ".app-list-confirm", function(e) {
				me.confirmAction(e,"confirm");
			});
            $(document).on("click", ".app-open-terms", function (e) {
                me.openTermsDialog(e);
            });

		},
		disableButton: function(e){
			e.preventDefault();
			return false;
		},
		confirmAction: function(e,action){
			var $this = $(e.currentTarget);
			if ($this.hasClass("app-disabled-button")) {
				return false;
			}
			e.preventDefault();
			var msg = "cancel" === action ? _app_.confirmCancel : _app_.confirmConfirm;
			var r = confirm(msg);
			if (r) {
				var form = $this.parents(".app-form");
				var tempElement = $("<input type='hidden'/>");
				tempElement
					.attr("name", $this.attr("name"))
					.val($this.val())
					.appendTo(form);
				form.submit();
			} else {
			  return false;
			}
		},

        /**
         * Open terms & conditions dialog
         */
        openTermsDialog: function () {
            var w = window.innerWidth;
            var dwidth = w - 30;
            if (w > 950) {
                dwidth = 950;
            }
            $("<div></div>").html($(".app-terms-text").html()).dialog({
                width: dwidth,
                title: $(".app-terms-title").text(),
                position: {my: "center top-50", at: "center top", of: window, collision: "none"},
                modal: !!_app_.modal,
                classes: {"ui-dialog": "app-terms"},
                dialogClass: "app-terms",
                buttons: [
                    {text: _app_.close || "Close",
                            click: function () {
                        $(this).dialog("close");
                    }}
                ]
            });
        },
		
		/**
		* Read signature
		*/
		sigPad: function(){
			if ( typeof SignaturePad !== "function" && typeof SignaturePad !== "object" ){
				return;
			}
			var wrapper = document.getElementById("signature-pad");
			if ( !$(wrapper).length ) {
				return false;
			}
			
			var clearButton = wrapper.querySelector("[data-action=clear]");
			var canvas = wrapper.querySelector("canvas");
			var sig_val = $(document).find("#signature-pad input.app-signature-value").val();
			$.sPad = new SignaturePad(canvas, {
				backgroundColor: 'rgb(255, 255, 255)',
				onEnd: function(){
					$(wrapper).data("signature", $.sPad.toData());
				}
			});

			$.sPad.fromData(sig_val);

			function resizeCanvas() {
				var ratio =  Math.max(window.devicePixelRatio || 1, 1);
				canvas.width = canvas.offsetWidth * ratio;
				canvas.height = canvas.offsetHeight * ratio;
				canvas.getContext("2d").scale(ratio, ratio);
				$.sPad.clear();
				var sigData = $(wrapper).data("signature");
				if ( sigData ) {
					$.sPad.fromData( sigData );
				}
			}
			window.onresize = resizeCanvas;
			resizeCanvas();
			
			$(document).on("app-conf-wrapper-opened", function(){
				resizeCanvas();
			});

			clearButton.addEventListener("click", function () {
			  $.sPad.clear();
			  $(wrapper).data("signature", null);
			});

			$(document).on("app-checkout-pre", function(){
				var dataURL = $.sPad.toDataURL();
				$(document).find("#signature-pad input.app-signature-value").val(dataURL);
			});
		}
	};

	WPB_Common.init();


	/**
	 * Arrange List of Bookings
	 */
	var WPB_List = {
		init: function() {
			var me = this;
			$.extend( $.fn.dataTableExt.oJUIClasses, {
				"sFilterInput": "ui-toolbar ui-state-default app-no-save-alert app-w-select",
				"sLengthSelect": "ui-toolbar ui-state-default app-no-save-alert"
			});
			$.fn.dataTable.moment( _app_.moment_format, _app_.locale );

			var dt = $("table.app-list").DataTable(me.args());
			$(document).find(".fg-toolbar").removeClass("ui-widget-header");
			dt.on("draw.dt", function () {
				$.styleButtons();
			});
			
			$(document).on( "click", ".app-list button.app-list-cancel", function(e) {
				var $this = $(this);
				if ($this.hasClass("app-disabled-button")) {
					return false;
				}
				e.preventDefault();
				$this.addClass("app-disabled-button");
				$this.closest("tr").css("opacity", "0.3");
				var r = window.confirm(_app_.cancel_app_confirm);
				if ( !r ) {
					$this.removeClass("app-disabled-button");
					$this.closest("tr").css("opacity", "1");
				} else {
					me.cancel($this);
				}
			});
			
			$(document).on( "click", ".app-list button.app-list-pay", function(e) {
				var $this = $(this);
				if ($this.hasClass("app-disabled-button")) {
					return false;
				}
				e.preventDefault();
				$this.addClass("app-disabled-button");
				$this.closest("tr").css("opacity", "0.3");
				window.location.href = $this.data("href");
			});			
		},

		/* DataTable arguments */
		args: function() {
			return {
				"bAutoWidth": true,
				"initComplete": $.styleButtons(),
				"fnInitComplete": function () {
					$(this).css({opacity: 0.0, visibility: "visible"}).animate({opacity: 1.0});
					$(".dataTables_filter input").attr("placeholder", _app_.search);
				},
				"lengthMenu": [ [10, 25, 50, 100, -1], [10, 25, 50, 100, _app_.all] ],
				"pageLength": _app_.page_length || 10,
				"responsive": true,
				"aaSorting": [ ],
				"bJQueryUI": true,
				"aoColumnDefs" : [ {
					"bSortable" : false,
					"aTargets" : [ 
						"app-list-gcal-header",
						"app-list-confirm-header",
						"app-list-edit-header",
						"app-list-cancel-header", 
						"app-list-pdf-header" 
					]
				} ],
				"language": {
					"info": _app_.info,
					"emptyTable": _app_.no_appointments,
					"paginate": {
					  "next": _app_.next,
					   "previous": _app_.previous
					},
					"search": "",
					"lengthMenu": _app_.length_menu
				}
			};
		},
		
		/* Handle cancel */
		cancel: function ($this) {
			var cancel_id = $this.data("app_id");
			if (!cancel_id) {
				return false;
			}
			
			$.infoPanel();
			
			var cancel_data = {
				action: "cancel_app", 
				app_id: cancel_id, 
				cancel_nonce: _app_.cancel_nonce, 
				args: $this.parents("table.app-list").data("args")
			};
			$.post(_app_.ajax_url, cancel_data, function(r) {
				$this.closest("tr").css("opacity", "1");
				if (!r) {
					alert(_app_.con_error);
					return false;
				}
				if (r.error ) {
					alert(r.error);
				} else if (r.success) {
					alert(_app_.cancelled);
					window.location.href = window.location.href;
				}
			}, "json");
		},
		
		/* Show children in qtip */
		qtip: function () {
			$(".app-list-service-name").qtip({
				overwrite: true,
				content: {
					text: function(ignore, api) {
						api.elements.content.html(_app_.please_wait);
						return $.ajax({
							url: _app_.ajax_url,
							type: "POST",
							dataType: "json",
							data: {
								wpb_ajax: true,
								app_id: $(this).data("app_id"),
								args: $(this).parents("table.app-list").data("args"),
								action: "app_show_children_in_tooltip"
							}
						})
						.then(function(res) {
							var content = res.result;
							return content;
						}, function(ignore, status, error) {
							api.set("content.text", status + ": " + error);
						});
					}
				},
				hide: _app_.qtipHide,
				position: _app_.qtipPos,
				style: _app_.qtipSmall
			});			
		}
	};

	WPB_List.init();
	

	$(document).on("click",".app-remove-image", function(){
		var $this = $(this);
		var par = $this.parents(".app-image-upload").first();
		var pholder = par.find(".pholder_img").val();
		
		par.find(".app-main-image").attr("src", pholder);
		par.find(".criteria-image-url").val("");
		$this.addClass("has-pholder");
	});

	var imgUploader;

	$(document).on('click','.app-upload-file-btn,.app-upload-image-btn', function(e) {
		e.preventDefault();

		var btn = $(this);
		var par = btn.parents("tr").first();
		
		imgUploader = wp.media.frames.file_frame = wp.media({
			title: _app_.choose_image,
			button: {
				text:  _app_.choose_image
			},
			multiple: false,
			library: {
				type: 'image'
			}
		});

		imgUploader.open();

		imgUploader.on('select', function() {
			var attachment = imgUploader.state().get('selection').first().toJSON();
			var url = attachment.url;
			var attachId = attachment.id;
			
		   par.find( "img.app-main-image" ).attr({
				src: url
			});
			par.find( ".criteria-image-url" ).val(url);
			
			par.find( ".criteria-image-id" ).val(attachId);
			
			par.find( ".app-remove-image" ).removeClass("has-pholder");
		});

	});

});